#ifndef YY_parse_h_included
#define YY_parse_h_included
/*#define YY_USE_CLASS 
*/
#line 1 "/usr/share/bison++/bison.h"
/* before anything */
#ifdef c_plusplus
 #ifndef __cplusplus
  #define __cplusplus
 #endif
#endif


 #line 8 "/usr/share/bison++/bison.h"

#line 1330 "parser.y"
typedef union {
  char  *id;
  List  *bases;
  struct Define {
    String *val;
    String *rawval;
    int     type;
    String *qualifier;
    String *bitfield;
    Parm   *throws;
    String *throwf;
  } dtype;
  struct {
    char *type;
    char *filename;
    int   line;
  } loc;
  struct {
    char      *id;
    SwigType  *type;
    String    *defarg;
    ParmList  *parms;
    short      have_parms;
    ParmList  *throws;
    String    *throwf;
  } decl;
  Parm         *tparms;
  struct {
    String     *op;
    Hash       *kwargs;
  } tmap;
  struct {
    String     *type;
    String     *us;
  } ptype;
  SwigType     *type;
  String       *str;
  Parm         *p;
  ParmList     *pl;
  int           ivalue;
  Node         *node;
} yy_parse_stype;
#define YY_parse_STYPE yy_parse_stype
#ifndef YY_USE_CLASS
#define YYSTYPE yy_parse_stype
#endif

#line 21 "/usr/share/bison++/bison.h"
 /* %{ and %header{ and %union, during decl */
#ifndef YY_parse_COMPATIBILITY
 #ifndef YY_USE_CLASS
  #define  YY_parse_COMPATIBILITY 1
 #else
  #define  YY_parse_COMPATIBILITY 0
 #endif
#endif

#if YY_parse_COMPATIBILITY != 0
/* backward compatibility */
 #ifdef YYLTYPE
  #ifndef YY_parse_LTYPE
   #define YY_parse_LTYPE YYLTYPE
/* WARNING obsolete !!! user defined YYLTYPE not reported into generated header */
/* use %define LTYPE */
  #endif
 #endif
/*#ifdef YYSTYPE*/
  #ifndef YY_parse_STYPE
   #define YY_parse_STYPE YYSTYPE
  /* WARNING obsolete !!! user defined YYSTYPE not reported into generated header */
   /* use %define STYPE */
  #endif
/*#endif*/
 #ifdef YYDEBUG
  #ifndef YY_parse_DEBUG
   #define  YY_parse_DEBUG YYDEBUG
   /* WARNING obsolete !!! user defined YYDEBUG not reported into generated header */
   /* use %define DEBUG */
  #endif
 #endif 
 /* use goto to be compatible */
 #ifndef YY_parse_USE_GOTO
  #define YY_parse_USE_GOTO 1
 #endif
#endif

/* use no goto to be clean in C++ */
#ifndef YY_parse_USE_GOTO
 #define YY_parse_USE_GOTO 0
#endif

#ifndef YY_parse_PURE

 #line 65 "/usr/share/bison++/bison.h"

#line 65 "/usr/share/bison++/bison.h"
/* YY_parse_PURE */
#endif


 #line 68 "/usr/share/bison++/bison.h"

#line 68 "/usr/share/bison++/bison.h"
/* prefix */

#ifndef YY_parse_DEBUG

 #line 71 "/usr/share/bison++/bison.h"

#line 71 "/usr/share/bison++/bison.h"
/* YY_parse_DEBUG */
#endif

#ifndef YY_parse_LSP_NEEDED

 #line 75 "/usr/share/bison++/bison.h"

#line 75 "/usr/share/bison++/bison.h"
 /* YY_parse_LSP_NEEDED*/
#endif

/* DEFAULT LTYPE*/
#ifdef YY_parse_LSP_NEEDED
 #ifndef YY_parse_LTYPE
  #ifndef BISON_YYLTYPE_ISDECLARED
   #define BISON_YYLTYPE_ISDECLARED
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;
  #endif

  #define YY_parse_LTYPE yyltype
 #endif
#endif

/* DEFAULT STYPE*/
#ifndef YY_parse_STYPE
 #define YY_parse_STYPE int
#endif

/* DEFAULT MISCELANEOUS */
#ifndef YY_parse_PARSE
 #define YY_parse_PARSE yyparse
#endif

#ifndef YY_parse_LEX
 #define YY_parse_LEX yylex
#endif

#ifndef YY_parse_LVAL
 #define YY_parse_LVAL yylval
#endif

#ifndef YY_parse_LLOC
 #define YY_parse_LLOC yylloc
#endif

#ifndef YY_parse_CHAR
 #define YY_parse_CHAR yychar
#endif

#ifndef YY_parse_NERRS
 #define YY_parse_NERRS yynerrs
#endif

#ifndef YY_parse_DEBUG_FLAG
 #define YY_parse_DEBUG_FLAG yydebug
#endif

#ifndef YY_parse_ERROR
 #define YY_parse_ERROR yyerror
#endif

#ifndef YY_parse_PARSE_PARAM
 #ifndef __STDC__
  #ifndef __cplusplus
   #ifndef YY_USE_CLASS
    #define YY_parse_PARSE_PARAM
    #ifndef YY_parse_PARSE_PARAM_DEF
     #define YY_parse_PARSE_PARAM_DEF
    #endif
   #endif
  #endif
 #endif
 #ifndef YY_parse_PARSE_PARAM
  #define YY_parse_PARSE_PARAM void
 #endif
#endif

/* TOKEN C */
#ifndef YY_USE_CLASS

 #ifndef YY_parse_PURE
  #ifndef yylval
   extern YY_parse_STYPE YY_parse_LVAL;
  #else
   #if yylval != YY_parse_LVAL
    extern YY_parse_STYPE YY_parse_LVAL;
   #else
    #warning "Namespace conflict, disabling some functionality (bison++ only)"
   #endif
  #endif
 #endif


 #line 169 "/usr/share/bison++/bison.h"
#define	ID	258
#define	HBLOCK	259
#define	POUND	260
#define	STRING	261
#define	INCLUDE	262
#define	IMPORT	263
#define	INSERT	264
#define	CHARCONST	265
#define	NUM_INT	266
#define	NUM_FLOAT	267
#define	NUM_UNSIGNED	268
#define	NUM_LONG	269
#define	NUM_ULONG	270
#define	NUM_LONGLONG	271
#define	NUM_ULONGLONG	272
#define	TYPEDEF	273
#define	TYPE_INT	274
#define	TYPE_UNSIGNED	275
#define	TYPE_SHORT	276
#define	TYPE_LONG	277
#define	TYPE_FLOAT	278
#define	TYPE_DOUBLE	279
#define	TYPE_CHAR	280
#define	TYPE_WCHAR	281
#define	TYPE_VOID	282
#define	TYPE_SIGNED	283
#define	TYPE_BOOL	284
#define	TYPE_COMPLEX	285
#define	TYPE_TYPEDEF	286
#define	TYPE_RAW	287
#define	TYPE_NON_ISO_INT8	288
#define	TYPE_NON_ISO_INT16	289
#define	TYPE_NON_ISO_INT32	290
#define	TYPE_NON_ISO_INT64	291
#define	LPAREN	292
#define	RPAREN	293
#define	COMMA	294
#define	SEMI	295
#define	EXTERN	296
#define	INIT	297
#define	LBRACE	298
#define	RBRACE	299
#define	PERIOD	300
#define	CONST_QUAL	301
#define	VOLATILE	302
#define	REGISTER	303
#define	STRUCT	304
#define	UNION	305
#define	EQUAL	306
#define	SIZEOF	307
#define	MODULE	308
#define	LBRACKET	309
#define	RBRACKET	310
#define	ILLEGAL	311
#define	CONSTANT	312
#define	NAME	313
#define	RENAME	314
#define	NAMEWARN	315
#define	EXTEND	316
#define	PRAGMA	317
#define	FEATURE	318
#define	VARARGS	319
#define	ENUM	320
#define	CLASS	321
#define	TYPENAME	322
#define	PRIVATE	323
#define	PUBLIC	324
#define	PROTECTED	325
#define	COLON	326
#define	STATIC	327
#define	VIRTUAL	328
#define	FRIEND	329
#define	THROW	330
#define	CATCH	331
#define	EXPLICIT	332
#define	USING	333
#define	NAMESPACE	334
#define	NATIVE	335
#define	INLINE	336
#define	TYPEMAP	337
#define	EXCEPT	338
#define	ECHO	339
#define	APPLY	340
#define	CLEAR	341
#define	SWIGTEMPLATE	342
#define	FRAGMENT	343
#define	WARN	344
#define	LESSTHAN	345
#define	GREATERTHAN	346
#define	MODULO	347
#define	DELETE_KW	348
#define	TYPES	349
#define	PARMS	350
#define	NONID	351
#define	DSTAR	352
#define	DCNOT	353
#define	TEMPLATE	354
#define	OPERATOR	355
#define	COPERATOR	356
#define	PARSETYPE	357
#define	PARSEPARM	358
#define	PARSEPARMS	359
#define	CAST	360
#define	LOR	361
#define	LAND	362
#define	OR	363
#define	XOR	364
#define	AND	365
#define	LSHIFT	366
#define	RSHIFT	367
#define	PLUS	368
#define	MINUS	369
#define	STAR	370
#define	SLASH	371
#define	UMINUS	372
#define	NOT	373
#define	LNOT	374
#define	DCOLON	375


#line 169 "/usr/share/bison++/bison.h"
 /* #defines token */
/* after #define tokens, before const tokens S5*/
#else
 #ifndef YY_parse_CLASS
  #define YY_parse_CLASS parse
 #endif

 #ifndef YY_parse_INHERIT
  #define YY_parse_INHERIT
 #endif

 #ifndef YY_parse_MEMBERS
  #define YY_parse_MEMBERS 
 #endif

 #ifndef YY_parse_LEX_BODY
  #define YY_parse_LEX_BODY  
 #endif

 #ifndef YY_parse_ERROR_BODY
  #define YY_parse_ERROR_BODY  
 #endif

 #ifndef YY_parse_CONSTRUCTOR_PARAM
  #define YY_parse_CONSTRUCTOR_PARAM
 #endif
 /* choose between enum and const */
 #ifndef YY_parse_USE_CONST_TOKEN
  #define YY_parse_USE_CONST_TOKEN 0
  /* yes enum is more compatible with flex,  */
  /* so by default we use it */ 
 #endif
 #if YY_parse_USE_CONST_TOKEN != 0
  #ifndef YY_parse_ENUM_TOKEN
   #define YY_parse_ENUM_TOKEN yy_parse_enum_token
  #endif
 #endif

class YY_parse_CLASS YY_parse_INHERIT
{
public: 
 #if YY_parse_USE_CONST_TOKEN != 0
  /* static const int token ... */
  
 #line 212 "/usr/share/bison++/bison.h"
static const int ID;
static const int HBLOCK;
static const int POUND;
static const int STRING;
static const int INCLUDE;
static const int IMPORT;
static const int INSERT;
static const int CHARCONST;
static const int NUM_INT;
static const int NUM_FLOAT;
static const int NUM_UNSIGNED;
static const int NUM_LONG;
static const int NUM_ULONG;
static const int NUM_LONGLONG;
static const int NUM_ULONGLONG;
static const int TYPEDEF;
static const int TYPE_INT;
static const int TYPE_UNSIGNED;
static const int TYPE_SHORT;
static const int TYPE_LONG;
static const int TYPE_FLOAT;
static const int TYPE_DOUBLE;
static const int TYPE_CHAR;
static const int TYPE_WCHAR;
static const int TYPE_VOID;
static const int TYPE_SIGNED;
static const int TYPE_BOOL;
static const int TYPE_COMPLEX;
static const int TYPE_TYPEDEF;
static const int TYPE_RAW;
static const int TYPE_NON_ISO_INT8;
static const int TYPE_NON_ISO_INT16;
static const int TYPE_NON_ISO_INT32;
static const int TYPE_NON_ISO_INT64;
static const int LPAREN;
static const int RPAREN;
static const int COMMA;
static const int SEMI;
static const int EXTERN;
static const int INIT;
static const int LBRACE;
static const int RBRACE;
static const int PERIOD;
static const int CONST_QUAL;
static const int VOLATILE;
static const int REGISTER;
static const int STRUCT;
static const int UNION;
static const int EQUAL;
static const int SIZEOF;
static const int MODULE;
static const int LBRACKET;
static const int RBRACKET;
static const int ILLEGAL;
static const int CONSTANT;
static const int NAME;
static const int RENAME;
static const int NAMEWARN;
static const int EXTEND;
static const int PRAGMA;
static const int FEATURE;
static const int VARARGS;
static const int ENUM;
static const int CLASS;
static const int TYPENAME;
static const int PRIVATE;
static const int PUBLIC;
static const int PROTECTED;
static const int COLON;
static const int STATIC;
static const int VIRTUAL;
static const int FRIEND;
static const int THROW;
static const int CATCH;
static const int EXPLICIT;
static const int USING;
static const int NAMESPACE;
static const int NATIVE;
static const int INLINE;
static const int TYPEMAP;
static const int EXCEPT;
static const int ECHO;
static const int APPLY;
static const int CLEAR;
static const int SWIGTEMPLATE;
static const int FRAGMENT;
static const int WARN;
static const int LESSTHAN;
static const int GREATERTHAN;
static const int MODULO;
static const int DELETE_KW;
static const int TYPES;
static const int PARMS;
static const int NONID;
static const int DSTAR;
static const int DCNOT;
static const int TEMPLATE;
static const int OPERATOR;
static const int COPERATOR;
static const int PARSETYPE;
static const int PARSEPARM;
static const int PARSEPARMS;
static const int CAST;
static const int LOR;
static const int LAND;
static const int OR;
static const int XOR;
static const int AND;
static const int LSHIFT;
static const int RSHIFT;
static const int PLUS;
static const int MINUS;
static const int STAR;
static const int SLASH;
static const int UMINUS;
static const int NOT;
static const int LNOT;
static const int DCOLON;


#line 212 "/usr/share/bison++/bison.h"
 /* decl const */
 #else
  enum YY_parse_ENUM_TOKEN { YY_parse_NULL_TOKEN=0
  
 #line 215 "/usr/share/bison++/bison.h"
	,ID=258
	,HBLOCK=259
	,POUND=260
	,STRING=261
	,INCLUDE=262
	,IMPORT=263
	,INSERT=264
	,CHARCONST=265
	,NUM_INT=266
	,NUM_FLOAT=267
	,NUM_UNSIGNED=268
	,NUM_LONG=269
	,NUM_ULONG=270
	,NUM_LONGLONG=271
	,NUM_ULONGLONG=272
	,TYPEDEF=273
	,TYPE_INT=274
	,TYPE_UNSIGNED=275
	,TYPE_SHORT=276
	,TYPE_LONG=277
	,TYPE_FLOAT=278
	,TYPE_DOUBLE=279
	,TYPE_CHAR=280
	,TYPE_WCHAR=281
	,TYPE_VOID=282
	,TYPE_SIGNED=283
	,TYPE_BOOL=284
	,TYPE_COMPLEX=285
	,TYPE_TYPEDEF=286
	,TYPE_RAW=287
	,TYPE_NON_ISO_INT8=288
	,TYPE_NON_ISO_INT16=289
	,TYPE_NON_ISO_INT32=290
	,TYPE_NON_ISO_INT64=291
	,LPAREN=292
	,RPAREN=293
	,COMMA=294
	,SEMI=295
	,EXTERN=296
	,INIT=297
	,LBRACE=298
	,RBRACE=299
	,PERIOD=300
	,CONST_QUAL=301
	,VOLATILE=302
	,REGISTER=303
	,STRUCT=304
	,UNION=305
	,EQUAL=306
	,SIZEOF=307
	,MODULE=308
	,LBRACKET=309
	,RBRACKET=310
	,ILLEGAL=311
	,CONSTANT=312
	,NAME=313
	,RENAME=314
	,NAMEWARN=315
	,EXTEND=316
	,PRAGMA=317
	,FEATURE=318
	,VARARGS=319
	,ENUM=320
	,CLASS=321
	,TYPENAME=322
	,PRIVATE=323
	,PUBLIC=324
	,PROTECTED=325
	,COLON=326
	,STATIC=327
	,VIRTUAL=328
	,FRIEND=329
	,THROW=330
	,CATCH=331
	,EXPLICIT=332
	,USING=333
	,NAMESPACE=334
	,NATIVE=335
	,INLINE=336
	,TYPEMAP=337
	,EXCEPT=338
	,ECHO=339
	,APPLY=340
	,CLEAR=341
	,SWIGTEMPLATE=342
	,FRAGMENT=343
	,WARN=344
	,LESSTHAN=345
	,GREATERTHAN=346
	,MODULO=347
	,DELETE_KW=348
	,TYPES=349
	,PARMS=350
	,NONID=351
	,DSTAR=352
	,DCNOT=353
	,TEMPLATE=354
	,OPERATOR=355
	,COPERATOR=356
	,PARSETYPE=357
	,PARSEPARM=358
	,PARSEPARMS=359
	,CAST=360
	,LOR=361
	,LAND=362
	,OR=363
	,XOR=364
	,AND=365
	,LSHIFT=366
	,RSHIFT=367
	,PLUS=368
	,MINUS=369
	,STAR=370
	,SLASH=371
	,UMINUS=372
	,NOT=373
	,LNOT=374
	,DCOLON=375


#line 215 "/usr/share/bison++/bison.h"
 /* enum token */
     }; /* end of enum declaration */
 #endif
public:
 int YY_parse_PARSE(YY_parse_PARSE_PARAM);
 virtual void YY_parse_ERROR(char *msg) YY_parse_ERROR_BODY;
 #ifdef YY_parse_PURE
  #ifdef YY_parse_LSP_NEEDED
   virtual int  YY_parse_LEX(YY_parse_STYPE *YY_parse_LVAL,YY_parse_LTYPE *YY_parse_LLOC) YY_parse_LEX_BODY;
  #else
   virtual int  YY_parse_LEX(YY_parse_STYPE *YY_parse_LVAL) YY_parse_LEX_BODY;
  #endif
 #else
  virtual int YY_parse_LEX() YY_parse_LEX_BODY;
  YY_parse_STYPE YY_parse_LVAL;
  #ifdef YY_parse_LSP_NEEDED
   YY_parse_LTYPE YY_parse_LLOC;
  #endif
  int YY_parse_NERRS;
  int YY_parse_CHAR;
 #endif
 #if YY_parse_DEBUG != 0
  public:
   int YY_parse_DEBUG_FLAG;	/*  nonzero means print parse trace	*/
 #endif
public:
 YY_parse_CLASS(YY_parse_CONSTRUCTOR_PARAM);
public:
 YY_parse_MEMBERS 
};
/* other declare folow */
#endif


#if YY_parse_COMPATIBILITY != 0
 /* backward compatibility */
 /* Removed due to bison problems
 /#ifndef YYSTYPE
 / #define YYSTYPE YY_parse_STYPE
 /#endif*/

 #ifndef YYLTYPE
  #define YYLTYPE YY_parse_LTYPE
 #endif
 #ifndef YYDEBUG
  #ifdef YY_parse_DEBUG 
   #define YYDEBUG YY_parse_DEBUG
  #endif
 #endif

#endif
/* END */

 #line 267 "/usr/share/bison++/bison.h"
#endif
